////////////////////////////////////////////////////////////////////////////////
// CSystem Class v1.0 by Krypt for Aurora v1.0 (RC1)
////////////////////////////////////////////////////////////////////////////////
// Date: 16 septembre 2007
// CSystem.inc
// En-ttes de CSystem.src
////////////////////////////////////////////////////////////////////////////////

#include "WindowsTypes.inc"

#ifndef Advapi32
#define Advapi32
  #use "advapi32.lib"
#EndIf

////////////////////////////////////////////////////////////////////////////////

struct SHELLEXECUTEINFO
{
        DWORD cbSize;
        ULONG fMask;
        HWND hwnd;
        LPCSTR *  lpVerb;
        LPCSTR *  lpFile;
        LPCSTR *  lpParameters;
        LPCSTR *  lpDirectory;
        int nShow;
        HINSTANCE hInstApp;
        // Optional fields
        LPVOID *lpIDList;
        LPCSTR *  lpClass;
        HKEY hkeyClass;
        DWORD dwHotKey;
        union 
		{
            HANDLE hIcon;
            HANDLE hMonitor;
        }
        HANDLE hProcess;
}

struct OSVERSIONINFO
{
	UNSIGNED INT dwOSVersionInfoSize;
	UNSIGNED INT dwMajorVersion;
	UNSIGNED INT dwMinorVersion;
	UNSIGNED INT dwBuildNumber;
	UNSIGNED INT dwPlatformId;
	DSTRING szCSDVersion[128];
}

struct OSVERSIONINFOEX
{
	UNSIGNED INT dwOSVersionInfoSize;
	UNSIGNED INT dwMajorVersion;
	UNSIGNED INT dwMinorVersion;
	UNSIGNED INT dwBuildNumber;
	UNSIGNED INT dwPlatformId;
	DSTRING szCSDVersion[128];
	WORD wServicePackMajor;
	WORD wServicePackMinor;
	WORD wSuiteMask;
	BYTE wProductType;
	BYTE wReserved;
}

////////////////////////////////////////////////////////////////////////////////

#define SEE_MASK_NO_CONSOLE        0x00008000
#define SEE_MASK_NOCLOSEPROCESS    0x00000040
#define WAIT_TIMEOUT               258

#define VER_PLATFORM_WIN32s          0
#define VER_PLATFORM_WIN32_WINDOWS   1
#define VER_PLATFORM_WIN32_NT        2
#define VER_NT_WORKSTATION         1
#define VER_NT_DOMAIN_CONTROLLER   2
#define VER_NT_SERVER              3
#define VER_SUITE_SMALLBUSINESS  1
#define VER_SUITE_ENTERPRISE     2
#define VER_SUITE_TERMINAL       16
#define VER_SUITE_DATACENTER     128
#define VER_SUITE_SINGLEUSERTS   256
#define VER_SUITE_PERSONAL       512
#define VER_SUITE_BLADE          1024

////////////////////////////////////////////////////////////////////////////////

class CSystem
{
	declare LaunchAPP(string App, string Command, opt int WaitTillClose, opt int Hide);
	declare GetSystemCurrentUsername(),STRING;
	declare GetWinOSName(),STRING;
	declare GetWinOSProductTypeNT(),STRING;
	declare GetWinOSServicePack(),STRING;
}